import { PipeTransform } from '@angular/core';
import { MockedComponent } from '../mock-component/types';
import { MockedDirective } from '../mock-directive/types';
import { MockedModule } from '../mock-module/types';
import { MockedPipe } from '../mock-pipe/types';
import { Type } from './core.types';
/**
 * Checks whether the instance derives from a mocked module.
 *
 * @see https://github.com/ike18t/ng-mocks#ismockof
 */
export declare function isMockOf<T>(instance: any, declaration: Type<T>, ngType: 'm'): instance is MockedModule<T>;
/**
 * Checks whether the instance derives from a mocked component.
 *
 * @see https://github.com/ike18t/ng-mocks#ismockof
 */
export declare function isMockOf<T>(instance: any, declaration: Type<T>, ngType: 'c'): instance is MockedComponent<T>;
/**
 * Checks whether the instance derives from a mocked directive.
 *
 * @see https://github.com/ike18t/ng-mocks#ismockof
 */
export declare function isMockOf<T>(instance: any, declaration: Type<T>, ngType: 'd'): instance is MockedDirective<T>;
/**
 * Checks whether the instance derives from a mocked pipe.
 *
 * @see https://github.com/ike18t/ng-mocks#ismockof
 */
export declare function isMockOf<T extends PipeTransform>(instance: any, declaration: Type<T>, ngType: 'p'): instance is MockedPipe<T>;
/**
 * Checks whether the instance derives from a mocked type.
 *
 * @see https://github.com/ike18t/ng-mocks#ismockof
 */
export declare function isMockOf<T>(instance: any, declaration: Type<T>): instance is T;
