import { InjectionToken, NgModule, PipeTransform, Provider } from '@angular/core';
import { TestBed } from '@angular/core/testing';
import { AnyType, Type } from '../common/core.types';
import { NgModuleWithProviders } from '../common/func.is-ng-module-def-with-providers';
import { IMockBuilderConfig, IMockBuilderResult } from './types';
export declare class MockBuilderPromise implements PromiseLike<IMockBuilderResult> {
    protected beforeCC: Set<(testBed: typeof TestBed) => void>;
    protected configDef: Map<Type<any> | InjectionToken<any>, any>;
    protected defProviders: Map<Type<any> | InjectionToken<any>, Provider[]>;
    protected defValue: Map<Type<any> | InjectionToken<any>, any>;
    protected excludeDef: Set<Type<any> | InjectionToken<any>>;
    protected keepDef: Set<Type<any> | InjectionToken<any>>;
    protected mockDef: Set<Type<any> | InjectionToken<any>>;
    protected providerDef: Map<Type<any> | InjectionToken<any>, Provider>;
    protected replaceDef: Set<Type<any> | InjectionToken<any>>;
    beforeCompileComponents(callback: (testBed: typeof TestBed) => void): this;
    build(): NgModule;
    exclude(def: any): this;
    keep<T>(def: NgModuleWithProviders<T>, config?: IMockBuilderConfig): this;
    keep<T>(token: InjectionToken<T>, config?: IMockBuilderConfig): this;
    keep<T>(def: AnyType<T>, config?: IMockBuilderConfig): this;
    keep(def: any, config?: IMockBuilderConfig): this;
    mock<T extends PipeTransform>(pipe: AnyType<T>, config?: IMockBuilderConfig): this;
    mock<T extends PipeTransform>(pipe: AnyType<T>, mock?: PipeTransform['transform'], config?: IMockBuilderConfig): this;
    mock<T>(token: InjectionToken<T>, mock: any, config: IMockBuilderConfig): this;
    mock<T>(provider: AnyType<T>, mock: AnyType<T>, config: IMockBuilderConfig): this;
    mock<T>(provider: AnyType<T>, mock: Partial<T>, config: IMockBuilderConfig): this;
    mock<T>(provider: AnyType<T>, mock: AnyType<T>, config: IMockBuilderConfig): this;
    mock<T>(token: InjectionToken<T>, mock?: any): this;
    mock<T>(def: NgModuleWithProviders<T>): this;
    mock<T>(def: AnyType<T>, config: IMockBuilderConfig): this;
    mock<T>(provider: AnyType<T>, mock?: Partial<T>): this;
    mock<T>(def: AnyType<T>): this;
    provide(def: Provider): this;
    replace(source: Type<any>, destination: Type<any>, config?: IMockBuilderConfig): this;
    then<TResult1 = IMockBuilderResult, TResult2 = never>(fulfill?: (value: IMockBuilderResult) => PromiseLike<TResult1>, reject?: (reason: any) => PromiseLike<TResult2>): PromiseLike<TResult1 | TResult2>;
    private wipe;
}
