import { Type } from '../common/core.types';
import { IMockRenderOptions, MockedComponentFixture } from './types';
/**
 * @see https://github.com/ike18t/ng-mocks#mockrender
 */
declare function MockRender<MComponent, TComponent extends {
    [key: string]: any;
}>(template: Type<MComponent>, params: TComponent, detectChanges?: boolean | IMockRenderOptions): MockedComponentFixture<MComponent, TComponent>;
/**
 * Without params we shouldn't autocomplete any keys of any types.
 *
 * @see https://github.com/ike18t/ng-mocks#mockrender
 */
declare function MockRender<MComponent extends Record<keyof any, any>>(template: Type<MComponent>): MockedComponentFixture<MComponent>;
/**
 * @see https://github.com/ike18t/ng-mocks#mockrender
 */
declare function MockRender<MComponent = any, TComponent extends {
    [key: string]: any;
} = {
    [key: string]: any;
}>(template: string, params: TComponent, detectChanges?: boolean | IMockRenderOptions): MockedComponentFixture<MComponent, TComponent>;
/**
 * Without params we shouldn't autocomplete any keys of any types.
 *
 * @see https://github.com/ike18t/ng-mocks#mockrender
 */
declare function MockRender<MComponent = any>(template: string): MockedComponentFixture<MComponent>;
export { MockRender };
